Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.usermodel
Class XSSFFormulaEvaluator

    java.lang.Object
      org.apache.poi.xssf.usermodel.XSSFFormulaEvaluator

All Implemented Interfaces:
  org.apache.poi.ss.usermodel.FormulaEvaluator

    public class XSSFFormulaEvaluator

extends java.lang.Object
implements org.apache.poi.ss.usermodel.FormulaEvaluator

Evaluates formula cells.

For performance reasons, this class keeps a cache of all previously calculated intermediate cell values. Be sure to call `clearAllCachedResultValues()` if any workbook cells are changed between calls to evaluate~ methods on this class.

Author:
  Amol S. Deshmukh < amolweb at ya hoo dot com >, Josh Micich

Constructor Summary
`XSSFFormulaEvaluator(XSSFWorkbook workbook)`
`XSSFFormulaEvaluator(XSSFWorkbook workbook, org.apache.poi.ss.formula.IStabilityClassifier stabilityClassifier)` Deprecated. (Sep 2009) (reduce overloading) use `create(XSSFWorkbook, org.apache.poi.ss.formula.IStabilityClassifier, org.apache.poi.ss.formula.udf.UDFFinder)`

Method Summary
`void` | `clearAllCachedResultValues()` Should be called whenever there are major changes (e.g.
`static XSSFFormulaEvaluator` | `create(XSSFWorkbook workbook, org.apache.poi.ss.formula.IStabilityClassifier stabilityClassifier, org.apache.poi.ss.formula.udf.UDFFinder udfFinder)`
`org.apache.poi.ss.usermodel.CellValue` | `evaluate(org.apache.poi.ss.usermodel.Cell cell)` If cell contains a formula, the formula is evaluated and returned, else the CellValue simply copies the appropriate cell value from the cell and also its cell type.
`void` | `evaluateAll()` Loops over all cells in all sheets of the supplied workbook.
`static void` | `evaluateAllFormulaCells(XSSFWorkbook wb)` Loops over all cells in all sheets of the supplied workbook.
`int` | `evaluateFormulaCell(org.apache.poi.ss.usermodel.Cell cell)` If cell contains formula, it evaluates the formula, and saves the result of the formula.
`org.apache.poi.ss.usermodel.Cell` | `evaluateInCell(org.apache.poi.ss.usermodel.Cell cell)` If cell contains formula, it evaluates the formula, and puts the formula result back into the cell, in place of the old formula.
`void` | `notifyDeleteCell(org.apache.poi.ss.usermodel.Cell cell)`
`void` | `notifySetFormula(org.apache.poi.ss.usermodel.Cell cell)`
`void` | `notifyUpdateCell(org.apache.poi.ss.usermodel.Cell cell)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XSSFFormulaEvaluator

    public XSSFFormulaEvaluator(XSSFWorkbook workbook)

### XSSFFormulaEvaluator

    public XSSFFormulaEvaluator(XSSFWorkbook workbook,
                                org.apache.poi.ss.formula.IStabilityClassifier stabilityClassifier)

  Deprecated. (Sep 2009) (reduce overloading) use `create(XSSFWorkbook, org.apache.poi.ss.formula.IStabilityClassifier, org.apache.poi.ss.formula.udf.UDFFinder)`

  Parameters:
    `stabilityClassifier` - used to optimise caching performance. Pass `null` for the (conservative) assumption that any cell may have its definition changed after evaluation begins.

Method Detail

### create

    public static XSSFFormulaEvaluator create(XSSFWorkbook workbook,
                                              org.apache.poi.ss.formula.IStabilityClassifier stabilityClassifier,
                                              org.apache.poi.ss.formula.udf.UDFFinder udfFinder)

  Parameters:
    `stabilityClassifier` - used to optimise caching performance. Pass `null` for the (conservative) assumption that any cell may have its definition changed after evaluation begins.
    `udfFinder` - pass `null` for default (AnalysisToolPak only)

### clearAllCachedResultValues

    public void clearAllCachedResultValues()

  Should be called whenever there are major changes (e.g. moving sheets) to input cells in the evaluated workbook. Failure to call this method after changing cell values will cause incorrect behaviour of the evaluate~ methods of this class

  Specified by:
    `clearAllCachedResultValues` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`

### notifySetFormula

    public void notifySetFormula(org.apache.poi.ss.usermodel.Cell cell)

  Specified by:
    `notifySetFormula` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`

### notifyDeleteCell

    public void notifyDeleteCell(org.apache.poi.ss.usermodel.Cell cell)

  Specified by:
    `notifyDeleteCell` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`

### notifyUpdateCell

    public void notifyUpdateCell(org.apache.poi.ss.usermodel.Cell cell)

  Specified by:
    `notifyUpdateCell` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`

### evaluate

    public org.apache.poi.ss.usermodel.CellValue evaluate(org.apache.poi.ss.usermodel.Cell cell)

  If cell contains a formula, the formula is evaluated and returned, else the CellValue simply copies the appropriate cell value from the cell and also its cell type. This method should be preferred over evaluateInCell() when the call should not modify the contents of the original cell.

  Specified by:
    `evaluate` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`
  Parameters:
    `cell` -

### evaluateFormulaCell

    public int evaluateFormulaCell(org.apache.poi.ss.usermodel.Cell cell)

  If cell contains formula, it evaluates the formula, and saves the result of the formula. The cell remains as a formula cell. Else if cell does not contain formula, this method leaves the cell unchanged. Note that the type of the formula result is returned, so you know what kind of value is also stored with the formula.

       int evaluatedCellType = evaluator.evaluateFormulaCell(cell);

  Be aware that your cell will hold both the formula, and the result. If you want the cell replaced with the result of the formula, use `evaluate(org.apache.poi.ss.usermodel.Cell)` }

  Specified by:
    `evaluateFormulaCell` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`
  Parameters:
    `cell` - The cell to evaluate
  Returns:
    The type of the formula result (the cell's type remains as HSSFCell.CELL_TYPE_FORMULA however)

### evaluateInCell

    public org.apache.poi.ss.usermodel.Cell evaluateInCell(org.apache.poi.ss.usermodel.Cell cell)

  If cell contains formula, it evaluates the formula, and puts the formula result back into the cell, in place of the old formula. Else if cell does not contain formula, this method leaves the cell unchanged. Note that the same instance of HSSFCell is returned to allow chained calls like:

       int evaluatedCellType = evaluator.evaluateInCell(cell).getCellType();

  Be aware that your cell value will be changed to hold the result of the formula. If you simply want the formula value computed for you, use `evaluateFormulaCell(org.apache.poi.ss.usermodel.Cell)` }

  Specified by:
    `evaluateInCell` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`
  Parameters:
    `cell` -

### evaluateAllFormulaCells

    public static void evaluateAllFormulaCells(XSSFWorkbook wb)

  Loops over all cells in all sheets of the supplied workbook. For cells that contain formulas, their formulas are evaluated, and the results are saved. These cells remain as formula cells. For cells that do not contain formulas, no changes are made. This is a helpful wrapper around looping over all cells, and calling evaluateFormulaCell on each one.

### evaluateAll

    public void evaluateAll()

  Loops over all cells in all sheets of the supplied workbook. For cells that contain formulas, their formulas are evaluated, and the results are saved. These cells remain as formula cells. For cells that do not contain formulas, no changes are made. This is a helpful wrapper around looping over all cells, and calling evaluateFormulaCell on each one.

  Specified by:
    `evaluateAll` in interface `org.apache.poi.ss.usermodel.FormulaEvaluator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD